/*
 * lxdata-a.0.c
 * Copyright (C) 2008-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <e4-m.0.h>
#include <e4.h>
#include <lxcall.h>
#include <lxdata-defs.h>
#include <lxdata-inter.h>
#include <lxdata-types.h>

#define MAKE_SINGLE(a, b)		a

#define l_append_args			2
#define l_append_name			8

#define l_append_size			fv_size(l_append_args, l_append_name)

/*
 * clear
 */
#define l_beyond_args			1
#define l_beyond_name			7

#define l_beyond_size			fv_size(l_beyond_args, l_beyond_name)

#define l_delete_args			2
#define l_delete_name			8

#define l_delete_size			fv_size(l_delete_args, l_delete_name)

/*
 * probe
 */
#define l_detect_args			3
#define l_detect_name			7

#define l_detect_size			fv_size(l_detect_args, l_detect_name)

/*
 * extend + add
 */
#define l_extend_args			2
#define l_extend_name			5

#define l_extend_size			fv_size(l_extend_args, l_extend_name)

/*
 * bill
 */
#define l_impose_args			4
#define l_impose_name			6

#define l_impose_size			fv_size(l_impose_args, l_impose_name)

#define l_insert_args			3
#define l_insert_name			8

#define l_insert_size			fv_size(l_insert_args, l_insert_name)

/*
 * trace
 */
#define l_locate_args			3
#define l_locate_name			7

#define l_locate_size			fv_size(l_locate_args, l_locate_name)

/*
 * cast
 */
#define l_record_args			2
#define l_record_name			6

#define l_record_size			fv_size(l_record_args, l_record_name)

/*
 * index
 */
#define l_sample_args			2
#define l_sample_name			7

#define l_sample_size			fv_size(l_sample_args, l_sample_name)

/*
 * suffix + fit
 */
#define l_suffix_args			2
#define l_suffix_name			5

#define l_suffix_size			fv_size(l_suffix_args, l_suffix_name)

/*
 * replace
 */
#define l_switch_args			3
#define l_switch_name			9

#define l_switch_size			fv_size(l_switch_args, l_switch_name)

/*
 * stock
 */
#define l_violet_args			3
#define l_violet_name			7

#define l_violet_size			fv_size(l_violet_args, l_violet_name)

/*
 * frame
 */
#define l_window_args			2
#define l_window_name			7

#define l_window_size			fv_size(l_window_args, l_window_name)

#define l________size \
    sizeof(struct x1f4_linetext_type)

#define fb_size()			1

#define fl_line(none) \
    (l_append_args							      \
     + l_beyond_args							      \
     + l_delete_args							      \
     + l_detect_args							      \
     + l_extend_args * 2						      \
     + l_impose_args							      \
     + l_insert_args							      \
     + l_locate_args							      \
     + l_record_args							      \
     + l_sample_args							      \
     + l_suffix_args * 2						      \
     + l_switch_args							      \
     + l_violet_args							      \
     + l_window_args)

#define fl_page(none) \
    17

#define fl_size(none) \
    (l_append_size							      \
     + l_beyond_size							      \
     + l_delete_size							      \
     + l_detect_size							      \
     + l_extend_size * 2						      \
     + l_impose_size							      \
     + l_insert_size							      \
     + l_locate_size							      \
     + l_record_size							      \
     + l_sample_size							      \
     + l_suffix_size * 2						      \
     + l_switch_size							      \
     + l_violet_size							      \
     + l_window_size							      \
     + l________size)

#define screen(screen) \
    ((struct screen_type *) (screen))

#define fv_size(args, name) \
    (sizeof(struct x1f4_linetext_type) + sizeof(int) * (args))

#define f1_size(year) \
    (year)

#define fa_size(year) \
    ((year) * sizeof(int))

#define ff_size(year) \
    ((year) * sizeof(struct x1f4_linetext_type))

#define q_case_args_____0 \
    struct lxdata_type *, const struct screen_type *,			      \
    struct x1f4_linetext_type *, void **, void **
#define q_case_args_____1 \
    struct lxdata_type *lxdata_data, const struct screen_type *screen_data,   \
    struct x1f4_linetext_type *linetext_data, void **args, void **dana
#define q_case_args_____2 \
    lxdata_data, screen_data, linetext_data, args, dana

static int init_data(struct lxdata_type *, unsigned,
		     const struct screen_type *);
static int line_afix(q_case_args_____0);
static int line_bfix(q_case_args_____0);
static int line_aset(q_case_args_____0);
static int line_cfix(q_case_args_____0);
static int line_cset(q_case_args_____0);
static int line_data(struct lxdata_type *, unsigned,
		     const struct screen_type *);
static int line_dfix(q_case_args_____0);
static int line_ffix(q_case_args_____0);
static int line_fset(q_case_args_____0);
static int line_ifix(q_case_args_____0);
static int line_iset(q_case_args_____0);
static int line_pmap(q_case_args_____0);
static int line_rfix(q_case_args_____0);
static int line_sfar(q_case_args_____0);
static int line_text(struct lxdata_type *, unsigned,
		     const struct screen_type *, void *, void **, void **);
static int line_tset(q_case_args_____0);
static int link_data(struct lxdata_type *, unsigned,
		     const struct screen_type *);
static int pass_aset(q_case_args_____0);
static int pass_ffix(q_case_args_____0);

static void line_bset(u_case_args_____0);
static void line_cmap(u_case_args_____0);
static void line_cway(u_case_args_____0);
static void line_efix(u_case_args_____0);
static void line_eway(u_case_args_____0);
static void line_fway(u_case_args_____0);
static void line_kfix(u_case_args_____0);
static void line_lfix(u_case_args_____0);
static void line_lmap(u_case_args_____0);
static void line_pfix(u_case_args_____0);
static void line_pway(u_case_args_____0);
static void line_rfar(u_case_args_____0);
static void line_rset(u_case_args_____0);
static void line_sfix(u_case_args_____0);
static void line_smap(u_case_args_____0);
static void line_snew(u_case_args_____0);
static void line_srun(u_case_args_____0);
static void line_sset(u_case_args_____0);
static void line_stip(u_case_args_____0);
static void line_sway(u_case_args_____0);
static void line_tfix(u_case_args_____0);

static const char fb_setf[] = "b_set", *const side_f[] = {
/* *INDENT-OFF* */
    fb_setf
/* *INDENT-ON* */
};
static const struct line_type ever_line[] = {
/* *INDENT-OFF* */
#define b_set_count			2
    {	{	fb_setf,
		_libx1f4i0_lxdata_s_pending,	0,
		NULL,				b_set_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,
						5		},
	line_smap,							}
#define b_set_reach			(0 + (b_set_count << 1))
/* *INDENT-ON* */
#define ever_line_count			b_set_reach
}, slip_line[] = {
/* *INDENT-OFF* */
#define b_character_count		2
    {	{	"b_character",
		_libx1f4i0_lxdata_t_logique,	X1f4_E4_MODE,
		NULL,				b_character_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						11		},
	line_tfix,							},
#define b_character_reach		(0 + b_character_count)
#define b_compare_count			2
    {	{	"b_compare",
		_libx1f4i0_lxdata_c_derived,	X1f4_E4_MODE,
		NULL,				b_compare_count,
		0,				9		},
	line_cway,							},
#define b_compare_reach			(b_character_reach + b_compare_count)
#define b_copy_count			2
    {	{	"b_copy",
		_libx1f4i0_lxdata_c_pending,	X1f4_E4_VOID,
		NULL,				b_copy_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_cmap,							},
#define b_copy_reach			(b_compare_reach + b_copy_count)
#define b_erase_count			3
    {	{	"b_erase",
		_libx1f4i0_lxdata_e_logique,	X1f4_E4_VOID,
		NULL,				b_erase_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	line_efix,							},
#define b_erase_reach			(b_copy_reach + b_erase_count)
#define b_even_count			3
    {	{	"b_even",
		_libx1f4i0_lxdata_e_derived,	X1f4_E4_MODE,
		NULL,				b_even_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_eway,							},
#define b_even_reach			(b_erase_reach + b_even_count)
#define b_find_count			2
    {	{	"b_find",
		_libx1f4i0_lxdata_f_derived,	X1f4_E4_MODE,
		NULL,				b_find_count,
		0,				6		},
	line_fway,							},
#define b_find_reach			(b_even_reach + b_find_count)
#define b_kill_count			3
    {	{	"b_kill",
		_libx1f4i0_lxdata_k_logique,	X1f4_E4_VOID,
		NULL,				b_kill_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_kfix,							},
#define b_kill_reach			(b_find_reach + b_kill_count)
#define b_length_count			1
    {	{	"b_length",
		_libx1f4i0_lxdata_l_logique,	X1f4_E4_MODE,
		NULL,				b_length_count,
		0,				8		},
	line_lfix,							},
#define b_length_reach			(b_kill_reach + b_length_count)
#define b_look_count			3
    {	{	"b_look",
		_libx1f4i0_lxdata_l_pending,	X1f4_E4_MODE,
		NULL,				b_look_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_lmap,							},
#define b_look_reach			(b_length_reach + b_look_count)
#define b_paste_count			3
    {	{	"b_paste",
		_libx1f4i0_lxdata_p_logique,	X1f4_E4_VOID,
		NULL,				b_paste_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	line_pfix,							},
#define b_paste_reach			(b_look_reach + b_paste_count)
#define b_patch_count			3
    {	{	"b_patch",
		_libx1f4i0_lxdata_p_forward,	X1f4_E4_VOID,
		NULL,				b_patch_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	line_bset,							},
#define b_patch_reach			(b_paste_reach + b_patch_count)
#define b_project_count			2
    {	{	"b_project",
		_libx1f4i0_lxdata_p_derived,	X1f4_E4_TEXT,
		NULL,				b_project_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						9		},
	line_pway,							},
#define b_project_reach			(b_patch_reach + b_project_count)
#define b_rate_count			3
    {	{	"b_rate",
		_libx1f4i0_lxdata_r_sequent,	X1f4_E4_MODE,
		NULL,				b_rate_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_rfar,							},
#define b_rate_reach			(b_project_reach + b_rate_count)
#define b_rule_count			5
    {	{	"b_rule",
		_libx1f4i0_lxdata_r_forward,	X1f4_E4_VOID,
		NULL,				b_rule_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_rset,							},
#define b_rule_reach			(b_rate_reach + b_rule_count)
#define b_scan_count			3
    {	{	"b_scan",
		_libx1f4i0_lxdata_s_general,	X1f4_E4_MODE,
		NULL,				b_scan_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_stip,							},
#define b_scan_reach			(b_rule_reach + b_scan_count)
#define b_scrap_count			3
    {	{	"b_scrap",
		_libx1f4i0_lxdata_s_nearest,	X1f4_E4_VOID,
		NULL,				b_scrap_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						7		},
	line_srun,							},
#define b_scrap_reach			(b_scan_reach + b_scrap_count)
#define b_side_count			3
    {	{	"b_side",
		_libx1f4i0_lxdata_s_harsher,	X1f4_E4_MODE,
		NULL,				b_side_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_snew,							},
#define b_side_reach			(b_scrap_reach + b_side_count)
#define b_size_count			2
    {	{	"b_size",
		_libx1f4i0_lxdata_s_derived,	X1f4_E4_VOID,
		NULL,				b_size_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_sway,							},
#define b_size_reach			(b_side_reach + b_size_count)
#define b_string_count			1
    {	{	"b_string",
		_libx1f4i0_lxdata_s_logique,	X1f4_E4_TEXT,
		NULL,				b_string_count,
		0,				8		},
	line_sfix,							},
#define b_string_reach			(b_size_reach + b_string_count)
#define b_swap_count			2
    {	{	"b_swap",
		_libx1f4i0_lxdata_s_forward,	X1f4_E4_VOID,
		NULL,				b_swap_count,
		X1f4_E4_KEEP_CALL,		6		},
	line_sset,							},
#define b_swap_reach			(b_string_reach + b_swap_count)
#define b_text_count			2
    {	{	"b_text",
		_libx1f4i0_lxdata_t_logique,	X1f4_E4_MODE,
		NULL,				b_text_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
						6		},
	line_tfix,							}
#define b_text_reach			(b_swap_reach + b_text_count)
/* *INDENT-ON* */
#define slip_line_count			b_text_reach
};
static const struct x1f4_operator_type side_o[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("=", " "),  NULL,		0400,
	0,			NULL,
	X1f4_E4_BACK_LINK | X1f4_E4_E2ND_LINK | X1f4_E4_LEFT_XSET,
				1,
	NULL,			NULL					}
/* *INDENT-ON* */
};

static int
init_data(struct lxdata_type *lxdata_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;

    if (bits & CODELINK_LINK) {
	lxdata_data->link_w.data = screen_data->link_w.data;
	lxdata_data->link_w.free = screen_data->link_w.free;
	lxdata_data->link_w.link = screen_data->link_w.link;
	lxdata_data->link_w.mode = screen_data->link_w.mode;
    } else {
	lxdata_data->link_w.data = NULL;
	lxdata_data->link_w.free = _x1f4_e4_free_data;
	lxdata_data->link_w.link = _x1f4_e4_link_data;
	lxdata_data->link_w.mode = _x1f4_e4_mode_data;
    }

    if (bits & RESOURCE_LINK) {
	lxdata_data->link_m.data = screen_data->link_m.data;
	lxdata_data->link_m.free = screen_data->link_m.free;
	lxdata_data->link_m.link = screen_data->link_m.link;
	lxdata_data->link_m.mode = screen_data->link_m.mode;
    } else {
	lxdata_data->link_m.data = NULL;
	lxdata_data->link_m.free = _x1f4_e4_free_data;
	lxdata_data->link_m.link = _x1f4_e4_link_data;
	lxdata_data->link_m.mode = _x1f4_e4_mode_data;
    }

    if (bits & TEXTFLAT_LINK) {
	lxdata_data->link_e.data = screen_data->link_e.data;
	lxdata_data->link_e.line = screen_data->link_e.line;
	lxdata_data->link_e.post = screen_data->link_e.post;
	lxdata_data->link_e.push = screen_data->link_e.push;
    } else {
	lxdata_data->link_e.data = NULL;
	lxdata_data->link_e.line = NULL;
	lxdata_data->link_e.post = NULL;
	lxdata_data->link_e.push = NULL;
    }

    status = link_data(lxdata_data, bits, screen_data);

    return status;
}


static int
line_afix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_a_logique;

    linetext_data->function.length = 8;

    linetext_data->function.name = "b_append";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_bfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 4;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_b_logique;

    linetext_data->function.length = 6;

    linetext_data->function.name = "b_bill";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_aset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_a_forward;

    linetext_data->function.length = 5;

    linetext_data->function.name = "b_add";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_cfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_c_logique;

    linetext_data->function.length = 7;

    linetext_data->function.name = "b_clear";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_cset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_c_forward;

    linetext_data->function.length = 6;

    linetext_data->function.name = "b_cast";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_data(struct lxdata_type *lxdata_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    lxdata_data->link_t.datatype[0].context = lxdata_data;

    lxdata_data->link_t.datatype[0].flat = _libx1f4i0_lxdata_flat_data;
    lxdata_data->link_t.datatype[0].lead = _libx1f4i0_lxdata_lead_data;
    lxdata_data->link_t.datatype[0].line = _libx1f4i0_lxdata_line_data;
    lxdata_data->link_t.datatype[0].link = _libx1f4i0_lxdata_link_data;
    lxdata_data->link_t.datatype[0].name = "data";
    lxdata_data->link_t.datatype[0].shut = _libx1f4i0_lxdata_flat_data;
    lxdata_data->link_t.datatype[0].slip = _libx1f4i0_lxdata_slip_data;
    lxdata_data->link_t.datatype[0].size = 4;
    lxdata_data->link_t.datatype[0].type = screen_data->link_l.type;

    lxdata_data->link_t.datatype[1].context = NULL;

    lxdata_data->link_t.datatype[1].flat = NULL;
    lxdata_data->link_t.datatype[1].lead = NULL;
    lxdata_data->link_t.datatype[1].line = NULL;
    lxdata_data->link_t.datatype[1].link = NULL;
    lxdata_data->link_t.datatype[1].name = NULL;
    lxdata_data->link_t.datatype[1].shut = NULL;
    lxdata_data->link_t.datatype[1].slip = NULL;
    lxdata_data->link_t.datatype[1].size = 0;
    lxdata_data->link_t.datatype[1].type = 0;

    return 0;
}


static int
line_dfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_d_logique;

    linetext_data->function.length = 8;

    linetext_data->function.name = "b_delete";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_ffix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_f_logique;

    linetext_data->function.length = 5;

    linetext_data->function.name = "b_fit";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_fset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_f_forward;

    linetext_data->function.length = 7;

    linetext_data->function.name = "b_frame";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_ifix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_i_logique;

    linetext_data->function.length = 8;

    linetext_data->function.name = "b_insert";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_iset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_i_forward;

    linetext_data->function.length = 7;

    linetext_data->function.name = "b_index";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_pmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_p_pending;

    linetext_data->function.length = 7;

    linetext_data->function.name = "b_probe";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_rfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_r_logique;

    linetext_data->function.length = 9;

    linetext_data->function.name = "b_replace";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_sfar(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_s_sequent;

    linetext_data->function.length = 7;

    linetext_data->function.name = "b_stock";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_text(struct lxdata_type *lxdata_data, unsigned bits,
	  const struct screen_type *screen_data, void *data, void **args,
	  void **dana)
{
    struct x1f4_linetext_type *linetext_data;

    linetext_data = data;

    if (1) {
	_libx1f4i0_lxcall_side_line
	    (lxdata_data, bits, screen_data, linetext_data, args,
	     sizeof(slip_line) / sizeof(struct line_type), slip_line);
	linetext_data += sizeof(slip_line) / sizeof(struct line_type);
    }
    if (bits & EVERLINK_SLIP) {
	_libx1f4i0_lxcall_side_line
	    (lxdata_data, bits, screen_data, linetext_data, args,
	     sizeof(ever_line) / sizeof(struct line_type), ever_line);
	linetext_data += sizeof(ever_line) / sizeof(struct line_type);
    }
    if (1) {
	line_aset(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_afix(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_bfix(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_cset(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_cfix(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_dfix(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	pass_aset(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_ffix(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_fset(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_iset(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_ifix(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_pmap(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_rfix(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_sfar(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	pass_ffix(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_tset(lxdata_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	_libx1f4i0_lxcall_zero_line(linetext_data);
    }

    return 0;
}


static int
line_tset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxdata_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxdata_t_forward;

    linetext_data->function.length = 7;

    linetext_data->function.name = "b_trace";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
link_data(struct lxdata_type *lxdata_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;
    unsigned args_count, line_count;
    void *data;

    args_count = 0;
    line_count = 0;

    {
	args_count += slip_line_count;
	line_count += sizeof(slip_line) / sizeof(struct line_type);
    }
    if (bits & EVERLINK_SLIP) {
	args_count += ever_line_count;
	line_count += sizeof(ever_line) / sizeof(struct line_type);
    }

    status = lxdata_data->link_w.link
	(lxdata_data->link_w.data, &data,
	 fl_size(none) + args_count * sizeof(int)
	 + line_count * sizeof(struct x1f4_linetext_type)
	 + (sizeof(struct tide_type) + sizeof(struct x1f4_operator_type *))
	 * fb_size() + sizeof(struct x1f4_operator_type *));
    if (status) {
	status = LINK_ERROR;
    } else {
	void *args, *dana, *side;

	side = (struct x1f4_linetext_type *) data + fl_page(none) + line_count;
	side = (struct tide_type *) side + fb_size();
	args = (struct x1f4_operator_type **) side + fb_size() + 1;

	lxdata_data->link_f.data = data;
	lxdata_data->link_f.side = side;

	line_text(lxdata_data, bits, screen_data, data, &args, &dana);
	_libx1f4i0_lxcall_line_side(side, data, side_o, side_f, fb_size());

	line_data(lxdata_data, bits, screen_data);
    }

    return status;
}


static int
pass_aset(q_case_args_____1)
{
    line_aset(q_case_args_____2);

    linetext_data->function.length = 8;

    linetext_data->function.name = "b_extend";

    return 0;
}


static int
pass_ffix(q_case_args_____1)
{
    line_ffix(q_case_args_____2);

    linetext_data->function.length = 8;

    linetext_data->function.name = "b_suffix";

    return 0;
}


static void
line_bset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_TEXT;

    *args = line;
}


static void
line_cmap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
line_cway(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
line_efix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_eway(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_TEXT;

    *args = line;
}


static void
line_fway(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
line_kfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_lfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
line_lmap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_TEXT;

    *args = line;
}


static void
line_pfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_TEXT;

    *args = line;
}


static void
line_pway(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_rfar(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_TEXT;

    *args = line;
}


static void
line_rset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;
}


static void
line_sfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
line_smap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;

    *args = line;

    linetext_data->function.type = screen(screen)->link_l.type;
}


static void
line_snew(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_TEXT;

    *args = line;
}


static void
line_srun(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;
}


static void
line_sset(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
line_stip(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = screen(screen)->link_l.type;

    *args = line;
}


static void
line_sway(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_tfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


int
x1f4_init_lxdata(void **lxdata, unsigned bits,
		 const struct screen_type *screen_data)
{
    int (*link) (void *, void **, unsigned), status;
    void *data, *text;

    if (bits & CODELINK_LINK) {
	link = screen_data->link_w.link;
	text = screen_data->link_w.data;
    } else {
	link = _x1f4_e4_link_data;
	text = (void *) 0;
    }

    status = link(text, &data, sizeof(struct lxdata_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	status = init_data(data, bits, screen_data);
	if (status) {
	    if (bits & CODELINK_LINK) {
		screen_data->link_w.free(text, data);
	    } else {
		_x1f4_e4_free_data(text, data);
	    }
	} else {
	    *lxdata = data;
	}
    }

    return status;
}
