/*
 * lxdata-f.p.c
 * Copyright (C) 2008-2011, 2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <e4.h>
#include <lxdata-inter.h>
#include <lxdata-size.h>
#include <lxdata-types.h>

#define I_DATA(t)			(*((X1f4_E4_C_USER *) (t)))
#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_TEXT(t)			(*((X1f4_E4_C_TEXT *) (t)))

#define becca(context) \
    ((void **) (context))

int
_libx1f4i0_lxdata_p_forward(void *context, void *output, void **input)
{
    int status;

    do {
	X1f4_E4_C_MODE rule;
	X1f4_E4_C_TEXT cast;
	struct dxdata_type *dxdata_data;
	unsigned mine, size;

	dxdata_data = I_DATA(input[0]);

	size = dxdata_data->length;

	rule = I_MODE(input[1]);

	size++;

	if (rule < 0) {
	    if ((X1f4_E4_C_MODE) size < -rule) {
		status = _libx1f4i0_lxdata_stat_deck
		    (*becca(context), size, -rule);
		if (1) {
		    break;
		}
	    } else {
		rule = size + rule;
	    }
	} else {
	    if (rule < size) {
	    } else {
		status = _libx1f4i0_lxdata_stat_deck
		    (*becca(context), size, rule);
		if (1) {
		    break;
		}
	    }
	}

	cast = I_TEXT(input[2]);

	mine = strlen(cast);

	if (mine) {
	    void *text;

	    text = dxdata_data->string;

	    size--;

	    if ((char *) cast < (char *) text
		|| (char *) text + size < (char *) cast) {
		status = _libx1f4i0_lxdata_rule_text
		    (*becca(context), dxdata_data, rule, mine, cast);
	    } else {
		unsigned fail;

		fail = rule + mine;

		if (size < fail) {
		    unsigned call, copy;

		    if (fail < 16) {
			copy = 16;
		    } else {
			text_size(copy, fail);
		    }

		    if (size < 16) {
			call = 16;
		    } else {
			text_size(call, size);
		    }
		    if (copy ^ call) {
			int offset;
			struct lxdata_type *lxdata_data;

			lxdata_data = *becca(context);

			offset = cast - (char *) text;

			status = lxdata_data->link_m.mode
			    (lxdata_data->link_m.data, &text, copy + 1);
			if (status) {
			    status = _libx1f4i0_lxdata_stat_mode(lxdata_data);
			    if (1) {
				break;
			    }
			}

			cast = (char *) text + offset;
		    } else {
			status = 0;
		    }

		    dxdata_data->length = fail;
		    dxdata_data->string = text;

		    if (1) {
			char *dana;

			dana = text;
			dana += fail;
			*dana = 0;
		    }
		} else {
		    status = 0;
		}

		memmove((char *) text + rule, cast, mine);
	    }
	} else {
	    status = 0;
	}
    } while (0);

    return status;
}
