/*
 * lxfile-a.0.c
 * Copyright (C) 2008-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <e4-m.0.h>
#include <e4.h>
#include <lxcall.h>
#include <lxfile-defs.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>

/*
 * TODO
 *
 *.improve on _data_ readers by not freeing the existing buffer.  it can be
 * achieved by messing with the memory allocator.
 *
 */

#define MAKE_SINGLE(a, b)		a

/*
 * bfxinteger
 */
#define l___bfxa_args			5
#define l___bfxa_name			12

#define l___bfxa_size			fv_size(l___bfxa_args, l___bfxa_name)

/*
 * bfxcardinal
 */
#define l___bfxe_args			5
#define l___bfxe_name			13

#define l___bfxe_size			fv_size(l___bfxe_args, l___bfxe_name)

/*
 * cardinal
 */
#define l___bill_args			2
#define l___bill_name			10

#define l___bill_size			fv_size(l___bill_args, l___bill_name)

#define l___byte_args			2
#define l___byte_name			6

#define l___byte_size			fv_size(l___byte_args, l___byte_name)

#define l___case_args			4
#define l___case_name			6

#define l___case_size			fv_size(l___case_args, l___case_name)

#define l___head_args			4
#define l___head_name			6

#define l___head_size			fv_size(l___head_args, l___head_name)

#define l___lead_args			4
#define l___lead_name			6

#define l___lead_size			fv_size(l___lead_args, l___lead_name)

#define l___list_args			3
#define l___list_name			6

#define l___look_args			2
#define l___look_name			6

#define l___look_size			fv_size(l___look_args, l___look_name)

/*
 * integer
 */
#define l___mode_args			2
#define l___mode_name			9

#define l___mode_size			fv_size(l___mode_args, l___mode_name)

#define l___open_args			4
#define l___open_name			6

#define l___open_size			fv_size(l___open_args, l___open_name)

#define l___peek_args			1
#define l___peek_name			6

#define l___peek_size			fv_size(l___peek_args, l___peek_name)

#define l___peep_args			2
#define l___peep_name			6

#define l___peep_size			fv_size(l___peep_args, l___peep_name)

#define l___pick_args			1
#define l___pick_name			6

#define l___pick_size			fv_size(l___pick_args, l___pick_name)

#define l___real_args			3
#define l___real_name			6

#define l___real_size			fv_size(l___real_args, l___real_name)

#define l___side_args			2
#define l___side_name			6

#define l___side_size			fv_size(l___side_args, l___side_name)

#define l___skip_args			2
#define l___skip_name			6

#define l___skip_size			fv_size(l___skip_args, l___skip_name)

#define l___slip_args			1
#define l___slip_name			6

#define l___slip_size			fv_size(l___slip_args, l___slip_name)

#define l___text_args			2
#define l___text_name			6

#define l___text_size			fv_size(l___text_args, l___text_name)

#define l___word_args			4
#define l___word_name			6

#define l___word_size			fv_size(l___word_args, l___word_name)

#define l__close_args			1
#define l__close_name			7

#define l__close_size			fv_size(l__close_args, l__close_name)

#define l__etext_args			2
#define l__etext_name			7

#define l__etext_size			fv_size(l__etext_args, l__etext_name)

#define l__flush_args			1
#define l__flush_name			7

#define l__flush_size			fv_size(l__flush_args, l__flush_name)

#define l__space_args			2
#define l__space_name			7

#define l__space_size			fv_size(l__space_args, l__space_name)

/*
 * wbfxinteger
 */
#define l__wbfxa_args			6
#define l__wbfxa_name			13

#define l__wbfxa_size			fv_size(l__wbfxa_args, l__wbfxa_name)

/*
 * wbfxcardinal
 */
#define l__wbfxe_args			6
#define l__wbfxe_name			14

#define l__wbfxe_size			fv_size(l__wbfxe_args, l__wbfxe_name)

/*
 * winteger
 */
#define l__wmode_args			3
#define l__wmode_name			10

#define l__wmode_size			fv_size(l__wmode_args, l__wmode_name)

/*
 * xcardinal
 */
#define l__xbill_args			3
#define l__xbill_name			11

#define l__xbill_size			fv_size(l__xbill_args, l__xbill_name)

/*
 * xinteger
 */
#define l__xmode_args			3
#define l__xmode_name			10

#define l__xmode_size			fv_size(l__xmode_args, l__xmode_name)

/*
 * fxcardinal
 */
#define l_fxbill_args			4
#define l_fxbill_name			12

#define l_fxbill_size			fv_size(l_fxbill_args, l_fxbill_name)

/*
 * fxinteger
 */
#define l_fxmode_args			4
#define l_fxmode_name			11

#define l_fxmode_size			fv_size(l_fxmode_args, l_fxmode_name)

/*
 * newline
 */
#define l_return_args			1
#define l_return_name			9

#define l_return_size			fv_size(l_return_args, l_return_name)

#define l_wpreal_args			5
#define l_wpreal_name			8

#define l_wpreal_size			fv_size(l_wpreal_args, l_wpreal_name)

#define l________size \
    sizeof(struct x1f4_linetext_type)

#define FFLAGS_KT			X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK
#define FFLAGS_KPT \
    X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK

#define fb_size()			1

#define fl_line(none) \
    (l___bfxa_args							      \
     + l___bfxe_args							      \
     + l___bill_args							      \
     + l___byte_args							      \
     + l___case_args							      \
     + l___head_args							      \
     + l___lead_args							      \
     + l___look_args							      \
     + l___mode_args							      \
     + l___open_args							      \
     + l___peek_args							      \
     + l___peep_args							      \
     + l___pick_args							      \
     + l___real_args							      \
     + l___side_args							      \
     + l___skip_args							      \
     + l___slip_args							      \
     + l___text_args							      \
     + l___word_args							      \
     + l__close_args							      \
     + l__etext_args							      \
     + l__flush_args							      \
     + l__space_args							      \
     + l__wbfxa_args							      \
     + l__wbfxe_args							      \
     + l__wmode_args							      \
     + l__xbill_args							      \
     + l__xmode_args							      \
     + l_fxbill_args							      \
     + l_fxmode_args							      \
     + l_return_args							      \
     + l_wpreal_args)

#define fl_page(none) \
    33

#define fl_size(none) \
    (l___bfxa_size							      \
     + l___bfxe_size							      \
     + l___bill_size							      \
     + l___byte_size							      \
     + l___case_size							      \
     + l___head_size							      \
     + l___lead_size							      \
     + l___look_size							      \
     + l___mode_size							      \
     + l___open_size							      \
     + l___peek_size							      \
     + l___peep_size							      \
     + l___pick_size							      \
     + l___real_size							      \
     + l___side_size							      \
     + l___skip_size							      \
     + l___slip_size							      \
     + l___text_size							      \
     + l___word_size							      \
     + l__close_size							      \
     + l__etext_size							      \
     + l__flush_size							      \
     + l__space_size							      \
     + l__wbfxa_size							      \
     + l__wbfxe_size							      \
     + l__wmode_size							      \
     + l__xbill_size							      \
     + l__xmode_size							      \
     + l_fxbill_size							      \
     + l_fxmode_size							      \
     + l_return_size							      \
     + l_wpreal_size							      \
     + l________size)

#define screen(screen) \
    ((struct screen_type *) (screen))

#define fv_size(args, name) \
    (sizeof(struct x1f4_linetext_type) + sizeof(int) * (args))

#define f1_size(year) \
    (year)

#define fa_size(year) \
    ((year) * sizeof(int))

#define ff_size(year) \
    ((year) * sizeof(struct x1f4_linetext_type))

#define q_case_args_____0 \
    struct lxfile_type *, const struct screen_type *,			      \
    struct x1f4_linetext_type *, void **, void **
#define q_case_args_____1 \
    struct lxfile_type *lxfile_data, const struct screen_type *screen_data,   \
    struct x1f4_linetext_type *linetext_data, void **args, void **dana
#define q_case_args_____2 \
    lxfile_data, screen_data, linetext_data, args, dana

static int init_file(struct lxfile_type *, unsigned,
		     const struct screen_type *);
static int line_bfix(q_case_args_____0);
static int line_bmap(q_case_args_____0);
static int line_bset(q_case_args_____0);
static int line_cfix(q_case_args_____0);
static int line_cmap(q_case_args_____0);
static int line_cset(q_case_args_____0);
static int line_efix(q_case_args_____0);
static int line_ffix(q_case_args_____0);
static int line_file(struct lxfile_type *, unsigned,
		     const struct screen_type *);
static int line_fmap(q_case_args_____0);
static int line_fset(q_case_args_____0);
static int line_hmap(q_case_args_____0);
static int line_imap(q_case_args_____0);
static int line_lmap(q_case_args_____0);
static int line_lset(q_case_args_____0);
static int line_lway(q_case_args_____0);
static int line_nfix(q_case_args_____0);
static int line_ofix(q_case_args_____0);
static int line_pfix(q_case_args_____0);
static int line_pmap(q_case_args_____0);
static int line_pset(q_case_args_____0);
static int line_rfix(q_case_args_____0);
static int line_sfix(q_case_args_____0);
static int line_srun(q_case_args_____0);
static int line_sset(q_case_args_____0);
static int line_sway(q_case_args_____0);
static int line_text(struct lxfile_type *, unsigned,
		     const struct screen_type *, void *, void **, void **);
static int line_tfix(q_case_args_____0);
static int line_wfix(q_case_args_____0);
static int line_wmap(q_case_args_____0);
static int line_wrun(q_case_args_____0);
static int line_wset(q_case_args_____0);
static int line_wway(q_case_args_____0);
static int line_xmap(q_case_args_____0);
static int line_xset(q_case_args_____0);
static int link_file(struct lxfile_type *, unsigned,
		     const struct screen_type *);
static int size_slip(unsigned *, unsigned *, unsigned);

static void line_afix(u_case_args_____0);
static void line_emap(u_case_args_____0);
static void line_ffar(u_case_args_____0);
static void line_fway(u_case_args_____0);
static void line_lfar(u_case_args_____0);
static void line_lfix(u_case_args_____0);
static void line_mway(u_case_args_____0);
static void line_nmap(u_case_args_____0);
static void line_pway(u_case_args_____0);
static void line_rmap(u_case_args_____0);
static void line_smap(u_case_args_____0);

static const char ff_setf[] = "f_set", *const side_f[] = {
/* *INDENT-OFF* */
    ff_setf
/* *INDENT-ON* */
};
static const struct line_type beta_line[] = {
/* *INDENT-OFF* */
#define l_b_fast_count			3
    {	{	"f_b_fast",
		_libx1f4i0_lxfile_f_sequent,	X1f4_E4_MODE,
		NULL,				l_b_fast_count,
		FFLAGS_KT,			8		},
	line_ffar,							},
#define l_b_fast_reach			l_b_fast_count
#define l_b_line_count			2
    {	{	"f_b_line",
		_libx1f4i0_lxfile_l_sequent,	X1f4_E4_MODE,
		NULL,				l_b_line_count,
		FFLAGS_KT,			8		},
	line_lfar,							},
#define l_b_line_reach			(l_b_fast_reach + l_b_line_count)
#define l_b_post_count			2
    {	{	"f_b_post",
		_libx1f4i0_lxfile_p_derived,	X1f4_E4_VOID,
		NULL,				l_b_post_count,
		FFLAGS_KT,			8		},
	line_pway,							},
#define l_b_post_reach			(l_b_line_reach + l_b_post_count)
#define l_b_read_count			3
    {	{	"f_b_read",
		_libx1f4i0_lxfile_r_pending,	X1f4_E4_MODE,
		NULL,				l_b_read_count,
		FFLAGS_KT,			8		},
	line_rmap,							}
#define l_b_read_reach			(l_b_post_reach + l_b_read_count)
/* *INDENT-ON* */
#define beta_line_count			l_b_read_reach
}, ever_line[] = {
/* *INDENT-OFF* */
#define l_set_count			2
    {	{	ff_setf,
		_libx1f4i0_lxfile_s_pending,	0,
		NULL,				l_set_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE
		| X1f4_E4_TEXT_LINK,
						5		},
	line_smap,							}
#define l_set_reach			(0 + (l_set_count << 1))
/* *INDENT-ON* */
#define ever_line_count			l_set_reach
}, slip_line[] = {
/* *INDENT-OFF* */
#define l_affix_count			2
    {	{	"f_affix",
		_libx1f4i0_lxfile_a_logique,	X1f4_E4_VOID,
		NULL,				l_affix_count,
		FFLAGS_KT,			7		},
	line_afix,							},
#define l_affix_reach			l_affix_count
#define l_ever_count			3
    {	{	"f_ever",
		_libx1f4i0_lxfile_e_pending,	X1f4_E4_MODE,
		NULL,				l_ever_count,
		FFLAGS_KPT,			6		},
	line_emap,							},
#define l_ever_reach			(l_affix_reach + (l_ever_count << 1))
#define l_fast_count			3
    {	{	"f_fast",
		_libx1f4i0_lxfile_f_derived,	X1f4_E4_MODE,
		NULL,				l_fast_count,
		FFLAGS_KPT,			6		},
	line_fway,							},
#define l_fast_reach			(l_ever_reach + (l_fast_count << 1))
#define l_line_count			2
    {	{	"f_line",
		_libx1f4i0_lxfile_l_logique,	X1f4_E4_MODE,
		NULL,				l_line_count,
		FFLAGS_KPT,			6		},
	line_lfix,							},
#define l_line_reach			(l_fast_reach + (l_line_count << 1))
#define l_mind_count			3
    {	{	"f_mind",
		_libx1f4i0_lxfile_m_derived,	X1f4_E4_MODE,
		NULL,				l_mind_count,
		FFLAGS_KPT,			6		},
	line_mway,							},
#define l_mind_reach			(l_line_reach + (l_mind_count << 1))
#define l_near_count			3
    {	{	"f_near",
		_libx1f4i0_lxfile_n_pending,	X1f4_E4_MODE,
		NULL,				l_near_count,
		FFLAGS_KPT,			6		},
	line_nmap,							}
#define l_near_reach			(l_mind_reach + (l_near_count << 1))
/* *INDENT-ON* */
#define slip_line_count			l_near_reach
};
static const struct x1f4_operator_type side_o[] = {
/* *INDENT-OFF* */
    {	MAKE_SINGLE("=", " "),  NULL,		0400,
	0,			NULL,
	X1f4_E4_BACK_LINK | X1f4_E4_E2ND_LINK | X1f4_E4_LEFT_XSET,
				1,
	NULL,			NULL					}
/* *INDENT-ON* */
};

static int
init_file(struct lxfile_type *lxfile_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;

    if (bits & CODELINK_LINK) {
	lxfile_data->link_w.data = screen_data->link_w.data;
	lxfile_data->link_w.free = screen_data->link_w.free;
	lxfile_data->link_w.link = screen_data->link_w.link;
	lxfile_data->link_w.mode = screen_data->link_w.mode;
    } else {
	lxfile_data->link_w.data = NULL;
	lxfile_data->link_w.free = _x1f4_e4_free_data;
	lxfile_data->link_w.link = _x1f4_e4_link_data;
	lxfile_data->link_w.mode = _x1f4_e4_mode_data;
    }

    if (bits & RESOURCE_LINK) {
	lxfile_data->link_m.data = screen_data->link_m.data;
	lxfile_data->link_m.free = screen_data->link_m.free;
	lxfile_data->link_m.link = screen_data->link_m.link;
	lxfile_data->link_m.mode = screen_data->link_m.mode;
    } else {
	lxfile_data->link_m.data = NULL;
	lxfile_data->link_m.free = _x1f4_e4_free_data;
	lxfile_data->link_m.link = _x1f4_e4_link_data;
	lxfile_data->link_m.mode = _x1f4_e4_mode_data;
    }

    if (bits & TEXTFLAT_LINK) {
	lxfile_data->link_e.data = screen_data->link_e.data;
	lxfile_data->link_e.line = screen_data->link_e.line;
	lxfile_data->link_e.post = screen_data->link_e.post;
	lxfile_data->link_e.push = screen_data->link_e.push;
    } else {
	lxfile_data->link_e.data = NULL;
	lxfile_data->link_e.line = NULL;
	lxfile_data->link_e.post = NULL;
	lxfile_data->link_e.push = NULL;
    }

    if (1) {
	lxfile_data->link_i.bits = bits;
    }

    status = link_file(lxfile_data, bits, screen_data);

    return status;
}


static int
line_bfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_b_logique;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_byte";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_bmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 5;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_b_pending;

    linetext_data->function.length = 12;

    linetext_data->function.name = "f_bfxinteger";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_bset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 5;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_b_forward;

    linetext_data->function.length = 13;

    linetext_data->function.name = "f_bfxcardinal";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_cfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_c_logique;

    linetext_data->function.length = 7;

    linetext_data->function.name = "f_close";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_cmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags =
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_c_pending;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_case";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_cset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_c_forward;

    linetext_data->function.length = 10;

    linetext_data->function.name = "f_cardinal";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_efix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_e_logique;

    linetext_data->function.length = 7;

    linetext_data->function.name = "f_etext";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_ffix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_f_logique;

    linetext_data->function.length = 7;

    linetext_data->function.name = "f_flush";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_file(struct lxfile_type *lxfile_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    lxfile_data->link_t.datatype[0].context = lxfile_data;

    lxfile_data->link_t.datatype[0].flat = _libx1f4i0_lxfile_flat_file;
    lxfile_data->link_t.datatype[0].lead = _libx1f4i0_lxfile_lead_file;
    lxfile_data->link_t.datatype[0].line = _libx1f4i0_lxfile_line_file;
    lxfile_data->link_t.datatype[0].link = _libx1f4i0_lxfile_link_file;
    lxfile_data->link_t.datatype[0].name = "file";
    lxfile_data->link_t.datatype[0].shut = _libx1f4i0_lxfile_shut_file;
    lxfile_data->link_t.datatype[0].slip = _libx1f4i0_lxfile_slip_file;
    lxfile_data->link_t.datatype[0].size = 4;
    lxfile_data->link_t.datatype[0].type = screen_data->link_l.type;

    lxfile_data->link_t.datatype[1].context = NULL;

    lxfile_data->link_t.datatype[1].flat = NULL;
    lxfile_data->link_t.datatype[1].lead = NULL;
    lxfile_data->link_t.datatype[1].line = NULL;
    lxfile_data->link_t.datatype[1].link = NULL;
    lxfile_data->link_t.datatype[1].name = NULL;
    lxfile_data->link_t.datatype[1].shut = NULL;
    lxfile_data->link_t.datatype[1].slip = NULL;
    lxfile_data->link_t.datatype[1].size = 0;
    lxfile_data->link_t.datatype[1].type = 0;

    return 0;
}


static int
line_fmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 4;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_f_pending;

    linetext_data->function.length = 11;

    linetext_data->function.name = "f_fxinteger";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_fset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 4;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_f_forward;

    linetext_data->function.length = 12;

    linetext_data->function.name = "f_fxcardinal";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_hmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags =
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_h_pending;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_head";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_imap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_i_pending;

    linetext_data->function.length = 9;

    linetext_data->function.name = "f_integer";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_lmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags =
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_l_pending;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_lead";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_lset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_l_forward;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_look";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_lway(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = screen_data->link_i.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_l_derived;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_list";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_nfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_n_logique;

    linetext_data->function.length = 9;

    linetext_data->function.name = "f_newline";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_ofix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 4;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_o_logique;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_open";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_pfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_p_logique;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_peek";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_pmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_p_pending;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_peep";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_pset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_p_forward;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_pick";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_rfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_REAL;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_r_logique;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_real";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_sfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_s_logique;

    linetext_data->function.length = 7;

    linetext_data->function.name = "f_space";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_srun(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_s_nearest;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_slip";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_sset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_s_forward;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_skip";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_sway(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_s_derived;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_side";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_text(struct lxfile_type *lxfile_data, unsigned bits,
	  const struct screen_type *screen_data, void *data, void **args,
	  void **dana)
{
    struct x1f4_linetext_type *linetext_data;

    linetext_data = data;

    if (1) {
	_libx1f4i0_lxcall_side_line
	    (lxfile_data, bits, screen_data, linetext_data, args,
	     sizeof(slip_line) / sizeof(struct line_type), slip_line);
	linetext_data += sizeof(slip_line) / sizeof(struct line_type);
    }
    if (bits & DATALINK_LINK) {
	_libx1f4i0_lxcall_side_line
	    (lxfile_data, bits, screen_data, linetext_data, args,
	     sizeof(beta_line) / sizeof(struct line_type), beta_line);
	linetext_data += sizeof(beta_line) / sizeof(struct line_type);
    }
    if (bits & EVERLINK_SLIP) {
	_libx1f4i0_lxcall_side_line
	    (lxfile_data, bits, screen_data, linetext_data, args,
	     sizeof(ever_line) / sizeof(struct line_type), ever_line);
	linetext_data += sizeof(ever_line) / sizeof(struct line_type);
    }
    if (1) {
	line_bset(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_bmap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_bfix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_cset(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_cmap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_cfix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_efix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_ffix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_fset(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_fmap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_hmap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_imap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_lmap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (bits & LISTLINK_LINK) {
	line_lway(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_lset(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_nfix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_ofix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_pfix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_pmap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_pset(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_rfix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_sway(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_sfix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_sset(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_srun(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_tfix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_wset(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_wfix(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_wway(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_wmap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_wrun(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_xset(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	line_xmap(lxfile_data, screen_data, linetext_data, args, dana);
	linetext_data++;
    }
    if (1) {
	_libx1f4i0_lxcall_zero_line(linetext_data);
    }

    return 0;
}


static int
line_tfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_t_logique;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_text";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_wfix(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 6;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_w_logique;

    linetext_data->function.length = 13;

    linetext_data->function.name = "f_wbfxinteger";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_wmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags =
	X1f4_E4_KEEP_CALL | X1f4_E4_POST_TYPE | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_w_pending;

    linetext_data->function.length = 6;

    linetext_data->function.name = "f_word";

    linetext_data->function.type = X1f4_E4_MODE;

    return 0;
}


static int
line_wrun(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_REAL;

    *args = line;

    linetext_data->function.count = 5;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_w_nearest;

    linetext_data->function.length = 8;

    linetext_data->function.name = "f_wpreal";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_wset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 6;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_w_forward;

    linetext_data->function.length = 14;

    linetext_data->function.name = "f_wbfxcardinal";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_wway(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_w_derived;

    linetext_data->function.length = 10;

    linetext_data->function.name = "f_winteger";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_xmap(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_x_pending;

    linetext_data->function.length = 10;

    linetext_data->function.name = "f_xinteger";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_xset(q_case_args_____1)
{
    int *line;

    linetext_data->context = lxfile_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen_data->link_l.type;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxfile_x_forward;

    linetext_data->function.length = 11;

    linetext_data->function.name = "f_xcardinal";

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
link_file(struct lxfile_type *lxfile_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;
    unsigned args_count, deck, line_count, near;
    void *data;

    args_count = 0;
    line_count = 0;

    size_slip(&near, &deck, bits);

    {
	args_count += slip_line_count;
	line_count += sizeof(slip_line) / sizeof(struct line_type);
    }
    if (bits & DATALINK_LINK) {
	args_count += beta_line_count;
	line_count += sizeof(beta_line) / sizeof(struct line_type);
    }
    if (bits & EVERLINK_SLIP) {
	args_count += ever_line_count;
	line_count += sizeof(ever_line) / sizeof(struct line_type);
    }

    status = lxfile_data->link_w.link
	(lxfile_data->link_w.data, &data, fl_size(none) + ff_size(deck)
	 + fa_size(near) + args_count * sizeof(int)
	 + line_count * sizeof(struct x1f4_linetext_type)
	 + (sizeof(struct tide_type) + sizeof(struct x1f4_operator_type *))
	 * fb_size() + sizeof(struct x1f4_operator_type *));
    if (status) {
	status = LINK_ERROR;
    } else {
	void *args, *dana, *side;

	side = (struct x1f4_linetext_type *) data + fl_page(none)
	    + f1_size(deck) + line_count;
	side = (struct tide_type *) side + fb_size();
	args = (struct x1f4_operator_type **) side + fb_size() + 1;

	lxfile_data->link_f.data = data;
	lxfile_data->link_f.side = side;

	line_text(lxfile_data, bits, screen_data, data, &args, &dana);
	_libx1f4i0_lxcall_line_side(side, data, side_o, side_f, fb_size());

	line_file(lxfile_data, bits, screen_data);
    }

    return status;
}


static int
size_slip(unsigned *slip, unsigned *text, unsigned bits)
{
    unsigned fast = 0, nand = 0;

    if (bits & LISTLINK_LINK) {
	fast += 1;
	nand += l___list_args;
    }

    *text = fast;
    *slip = nand;

    return 0;
}


static void
line_afix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_TEXT;

    *args = line;
}


static void
line_emap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
line_ffar(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = screen(screen)->link_f.type;

    *args = line;
}


static void
line_fway(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
line_lfar(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_f.type;

    *args = line;
}


static void
line_lfix(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
line_mway(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
line_nmap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_TEXT;
    *line++ = X1f4_E4_TEXT;
    *line++ = 0;
    *line++ = 0;
    *line++ = X1f4_E4_POST_XSET;

    *args = line;
}


static void
line_pway(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_f.type;

    *args = line;
}


static void
line_rmap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_f.type;
    *line++ = X1f4_E4_MODE;

    *args = line;
}


static void
line_smap(u_case_args_____1)
{
    int *line;

    line = *args;

    linetext_data->function.args = line;

    *line++ = screen(screen)->link_l.type;
    *line++ = screen(screen)->link_l.type;
    *line++ = X1f4_E4_POST_XSET;
    *line++ = 0;

    *args = line;

    linetext_data->function.type = screen(screen)->link_l.type;
}


int
x1f4_init_lxfile(void **lxfile, unsigned bits,
		 const struct screen_type *screen_data)
{
    int (*link) (void *, void **, unsigned), status;
    void *file, *text;

    if (bits & CODELINK_LINK) {
	link = screen_data->link_w.link;
	text = screen_data->link_w.data;
    } else {
	link = _x1f4_e4_link_data;
	text = (void *) 0;
    }

    status = link(text, &file, sizeof(struct lxfile_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	status = init_file(file, bits, screen_data);
	if (status) {
	    if (bits & CODELINK_LINK) {
		screen_data->link_w.free(text, file);
	    } else {
		_x1f4_e4_free_data(text, file);
	    }
	} else {
	    *lxfile = file;
	}
    }

    return status;
}
