/*
 * lxnear-a.0.c
 * Copyright (C) 2008-2013, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <e4-m.0.h>
#include <e4.h>
#include <lxcall.h>
#include <lxnear-defs.h>
#include <lxnear-inter.h>
#include <lxnear-types.h>

/*
 * bfxinteger
 */
#define l___bfxa_args			4
#define l___bfxa_name			11

#define l___bfxa_size			fx_size(l___bfxa_args, l___bfxa_name)

/*
 * bfxcardinal
 */
#define l___bfxe_args			4
#define l___bfxe_name			12

#define l___bfxe_size			fx_size(l___bfxe_args, l___bfxe_name)

/*
 * cardinal
 */
#define l___bill_args			1
#define l___bill_name			9

#define l___bill_size			fx_size(l___bill_args, l___bill_name)

#define l___byte_args			1
#define l___byte_name			5

#define l___byte_size			fx_size(l___byte_args, l___byte_name)

/*
 * integer
 */
#define l___mode_args			1
#define l___mode_name			8

#define l___mode_size			fx_size(l___mode_args, l___mode_name)

#define l___real_args			2
#define l___real_name			5

#define l___real_size			fx_size(l___real_args, l___real_name)

#define l___text_args			1
#define l___text_name			5

#define l___text_size			fx_size(l___text_args, l___text_name)

#define l__etext_args			1
#define l__etext_name			6

#define l__etext_size			fx_size(l__etext_args, l__etext_name)

#define l__space_args			1
#define l__space_name			6

#define l__space_size			fx_size(l__space_args, l__space_name)

/*
 * wbfxinteger
 */
#define l__wbfxa_args			5
#define l__wbfxa_name			12

#define l__wbfxa_size			fx_size(l__wbfxa_args, l__wbfxa_name)

/*
 * wbfxcardinal
 */
#define l__wbfxe_args			5
#define l__wbfxe_name			13

#define l__wbfxe_size			fx_size(l__wbfxe_args, l__wbfxe_name)

/*
 * winteger
 */
#define l__wmode_args			2
#define l__wmode_name			9

#define l__wmode_size			fx_size(l__wmode_args, l__wmode_name)

/*
 * xcardinal
 */
#define l__xbill_args			2
#define l__xbill_name			10

#define l__xbill_size			fx_size(l__xbill_args, l__xbill_name)

/*
 * xinteger
 */
#define l__xmode_args			2
#define l__xmode_name			9

#define l__xmode_size			fx_size(l__xmode_args, l__xmode_name)

/*
 * fxcardinal
 */
#define l_fxbill_args			3
#define l_fxbill_name			11

#define l_fxbill_size			fx_size(l_fxbill_args, l_fxbill_name)

/*
 * fxinteger
 */
#define l_fxmode_args			3
#define l_fxmode_name			10

#define l_fxmode_size			fx_size(l_fxmode_args, l_fxmode_name)

#define l_wpreal_args			4
#define l_wpreal_name			7

#define l_wpreal_size			fx_size(l_wpreal_args, l_wpreal_name)

#define l___type_size \
    (l___bfxa_size							      \
     + l___bfxe_size							      \
     + l___bill_size							      \
     + l___byte_size							      \
     + l___mode_size							      \
     + l___real_size							      \
     + l___text_size							      \
     + l__etext_size							      \
     + l__space_size							      \
     + l__wbfxa_size							      \
     + l__wbfxe_size							      \
     + l__wmode_size							      \
     + l__xbill_size							      \
     + l__xmode_size							      \
     + l_fxbill_size							      \
     + l_fxmode_size							      \
     + l_wpreal_size)

#define l___type_page \
    17

#define l___type_line \
    (l___bfxa_args							      \
     + l___bfxe_args							      \
     + l___bill_args							      \
     + l___byte_args							      \
     + l___mode_args							      \
     + l___real_args							      \
     + l___text_args							      \
     + l__etext_args							      \
     + l__space_args							      \
     + l__wbfxa_args							      \
     + l__wbfxe_args							      \
     + l__wmode_args							      \
     + l__xbill_args							      \
     + l__xmode_args							      \
     + l_fxbill_args							      \
     + l_fxmode_args							      \
     + l_wpreal_args)

#define l________size \
    sizeof(struct x1f4_linetext_type)

#define fl_page(none) \
    1

#define fl_size(none) \
    (l________size)

#define ft_line(miss) \
    ((miss) * l___type_line)

#define ft_page(miss) \
    ((miss) * l___type_page)

#define ft_size(miss) \
    ((miss) * (l___type_size + sizeof(struct lxtext_type)))

#define fx_size(args, name) \
    (sizeof(struct x1f4_linetext_type) + sizeof(int) * (args) + (name) + 1)

#define fy_size(year) \
    (year)

#define f1_size(year) \
    (year)

#define fa_size(year) \
    ((year) * sizeof(int))

#define ff_size(year) \
    ((year) * sizeof(struct x1f4_linetext_type))

#define p_case_args_____0 \
    struct lxnear_type *, const struct screen_type *,			      \
    struct x1f4_linetext_type *, struct lxtext_type *,			      \
    const struct lxtype_type *, void **, void **
#define p_case_args_____1 \
    struct lxnear_type *lxnear_data, const struct screen_type *screen_data,   \
    struct x1f4_linetext_type *linetext_data,				      \
    struct lxtext_type *lxtext_data, const struct lxtype_type *lxtype_data,   \
    void **args, void **dana
#define p_case_args_____2 \
    lxnear_data, screen_data, linetext_data, lxtext_data, lxtype_data, args,  \
    dana

#define p_case_args__			p_case_args______

#define p_case_args______(lxnear_data, screen_data, linetext_data, \
			  lxtext_data, lxtype_data, args, dana)		      \
    (lxnear_data), (screen_data), (linetext_data), (lxtext_data),	      \
    (lxtype_data), (args), (dana)

typedef struct miss_type {
    struct x1f4_function_type function;
} miss_type;

static int init_near(struct lxnear_type *, unsigned,
		     const struct screen_type *);
static int line_bfix(p_case_args_____0);
static int line_bmap(p_case_args_____0);
static int line_bset(p_case_args_____0);
static int line_data(struct lxnear_type *, unsigned,
		     const struct screen_type *, void *, void *, void **,
		     void **);
static int line_efix(p_case_args_____0);
static int line_ffix(p_case_args_____0);
static int line_fset(p_case_args_____0);
static int line_ifix(p_case_args_____0);
static int line_rfix(p_case_args_____0);
static int line_sfix(p_case_args_____0);
static int line_tfix(p_case_args_____0);
static int line_sail(struct lxnear_type *, const struct screen_type *,
		     struct x1f4_linetext_type **, struct lxtext_type *,
		     const struct lxtype_type *, void **, void **);
static int line_wfix(p_case_args_____0);
static int line_wmap(p_case_args_____0);
static int line_wset(p_case_args_____0);
static int line_wway(p_case_args_____0);
static int line_xfix(p_case_args_____0);
static int line_xset(p_case_args_____0);
static int link_near(struct lxnear_type *, unsigned,
		     const struct screen_type *);
static int pick_miss(unsigned *, unsigned *, unsigned *,
		     const struct screen_type *);
static int size_miss(unsigned *, unsigned *, unsigned *, unsigned *,
		     unsigned *, unsigned *, const struct screen_type *);

static void side_line(void *, unsigned, const struct screen_type *,
		      struct x1f4_linetext_type *, const struct lxtype_type *,
		      void **, unsigned, const struct miss_type *);

static const int red_m_b__[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE,
    X1f4_E4_BILL
/* *INDENT-ON* */
}, red_m_m__[] = {
/* *INDENT-OFF* */
    X1f4_E4_MODE,
    X1f4_E4_MODE
/* *INDENT-ON* */
};
static const struct miss_type fast_line[] = {
/* *INDENT-OFF* */
#define l_fcardinal_class		10
#define l_fcardinal_count		2
    {	{	"_fcardinal",
		_libx1f4i0_lxnear_f_sequent,	X1f4_E4_VOID,
		red_m_b__,			l_fcardinal_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
					l_fcardinal_class	},	},
#define l_fcardinal_reach		(0 + l_fcardinal_count)
#define l_fcardinal_trans		(0 + l_fcardinal_class)
#define l_finteger_class		9
#define l_finteger_count		2
    {	{	"_finteger",
		_libx1f4i0_lxnear_f_derived,	X1f4_E4_VOID,
		red_m_m__,			l_finteger_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
					l_finteger_class	},	},
#define l_finteger_reach		(l_fcardinal_reach + l_finteger_count)
#define l_finteger_trans		(l_fcardinal_trans + l_finteger_class)
#define l_newline_class			8
#define l_newline_count			0
    {	{	"_newline",
		_libx1f4i0_lxnear_n_logique,	X1f4_E4_VOID,
		NULL,				l_newline_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
					l_newline_class		},	},
#define l_newline_reach			(l_finteger_reach + l_newline_count)
#define l_newline_trans			(l_finteger_trans + l_newline_class)
#define l_wcardinal_class		10
#define l_wcardinal_count		2
    {	{	"_wcardinal",
		_libx1f4i0_lxnear_w_sequent,	X1f4_E4_VOID,
		red_m_b__,			l_wcardinal_count,
		X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK,
					l_wcardinal_class	},	}
#define l_wcardinal_reach		(l_newline_reach + l_wcardinal_count)
#define l_wcardinal_trans		(l_newline_trans + l_wcardinal_class)
/* *INDENT-ON* */
#define fast_line_class			l_wcardinal_trans
#define fast_line_count			l_wcardinal_reach
#undef fast_line_count
#define fast_line_count			0
};

static int
init_near(struct lxnear_type *lxnear_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;

    if (bits & CODELINK_LINK) {
	lxnear_data->link_w.data = screen_data->link_w.data;
	lxnear_data->link_w.free = screen_data->link_w.free;
	lxnear_data->link_w.link = screen_data->link_w.link;
	lxnear_data->link_w.mode = screen_data->link_w.mode;
    } else {
	lxnear_data->link_w.data = NULL;
	lxnear_data->link_w.free = _x1f4_e4_free_data;
	lxnear_data->link_w.link = _x1f4_e4_link_data;
	lxnear_data->link_w.mode = _x1f4_e4_mode_data;
    }

    if (bits & TEXTFLAT_LINK) {
	lxnear_data->link_e.data = screen_data->link_e.data;
	lxnear_data->link_e.line = screen_data->link_e.line;
	lxnear_data->link_e.post = screen_data->link_e.post;
	lxnear_data->link_e.push = screen_data->link_e.push;
    } else {
	lxnear_data->link_e.data = NULL;
	lxnear_data->link_e.line = NULL;
	lxnear_data->link_e.post = NULL;
	lxnear_data->link_e.push = NULL;
    }

    status = link_near(lxnear_data, bits, screen_data);

    return status;
}


static int
line_bfix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_b_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 5;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_byte", 6);

    *dana = text + 6;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_bmap(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 4;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_b_pending;

    size = lxtype_data->size;

    linetext_data->function.length = size + 12;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_bfxcardinal", 13);

    *dana = text + 13;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_bset(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 4;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_b_forward;

    size = lxtype_data->size;

    linetext_data->function.length = size + 11;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_bfxinteger", 12);

    *dana = text + 12;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_cfix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_c_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 9;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_cardinal", 10);

    *dana = text + 10;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_data(struct lxnear_type *lxnear_data, unsigned bits,
	  const struct screen_type *screen_data, void *data, void *text,
	  void **args, void **dana)
{
    struct lxtext_type *lxtext_data;
    const struct lxtype_type *lxtype_data;
    struct x1f4_linetext_type *linetext_data;
    unsigned i;

    lxtype_data = screen_data->link_t.data;

    linetext_data = data;
    lxtext_data = text;

    i = screen_data->link_t.miss;
    for (; i; i--) {
	line_sail
	    (lxnear_data, screen_data, &linetext_data, lxtext_data,
	     lxtype_data, args, dana);
	if (1) {
	    side_line
		(lxtext_data, bits, screen_data, linetext_data, lxtype_data,
		 dana, sizeof(fast_line) / sizeof(struct miss_type),
		 fast_line);
	    linetext_data += sizeof(fast_line) / sizeof(struct miss_type);
	}

	lxtext_data++;

	lxtype_data++;
    }

    {
	_libx1f4i0_lxcall_zero_line(linetext_data);
    }

    return 0;
}


static int
line_efix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_TEXT;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_e_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 6;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_etext", 7);

    *dana = text + 7;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_ffix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_f_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 10;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_fxinteger", 11);

    *dana = text + 11;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_fset(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 3;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_f_forward;

    size = lxtype_data->size;

    linetext_data->function.length = size + 11;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_fxcardinal", 12);

    *dana = text + 12;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_ifix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_i_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 8;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_integer", 9);

    *dana = text + 9;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_rfix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_REAL;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_r_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 5;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_real", 6);

    *dana = text + 6;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_sfix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_s_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 6;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_space", 7);

    *dana = text + 7;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_tfix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_TEXT;

    *args = line;

    linetext_data->function.count = 1;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_t_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 5;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_text", 6);

    *dana = text + 6;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_sail(struct lxnear_type *lxnear_data,
	  const struct screen_type *screen_data,
	  struct x1f4_linetext_type **linetext,
	  struct lxtext_type *lxtext_data,
	  const struct lxtype_type *lxtype_data, void **subtext, void **dana)
{
    struct x1f4_linetext_type *linetext_data;

    linetext_data = *linetext;

    lxtext_data->data = lxtype_data->text;
    lxtext_data->push = lxtype_data->copy;
    lxtext_data->text = lxnear_data;

    if (1) {
	line_bmap(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_bset(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_bfix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_cfix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_efix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_fset(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_ffix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_ifix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_rfix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_sfix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_tfix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_wway(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_wfix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_wset(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_wmap(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_xset(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }
    if (1) {
	line_xfix(p_case_args__(lxnear_data, screen_data, linetext_data,
				lxtext_data, lxtype_data, subtext, dana));
	linetext_data++;
    }

    *linetext = linetext_data;

    return 0;
}


static int
line_wfix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 5;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_w_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 12;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_wbfxinteger", 13);

    *dana = text + 13;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_wmap(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_REAL;

    *args = line;

    linetext_data->function.count = 4;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_w_pending;

    size = lxtype_data->size;

    linetext_data->function.length = size + 7;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_wpreal", 8);

    *dana = text + 8;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_wset(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_w_forward;

    size = lxtype_data->size;

    linetext_data->function.length = size + 9;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_winteger", 10);

    *dana = text + 10;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_wway(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 5;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_w_derived;

    size = lxtype_data->size;

    linetext_data->function.length = size + 13;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_wbfxcardinal", 14);

    *dana = text + 14;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_xfix(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_MODE;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_x_logique;

    size = lxtype_data->size;

    linetext_data->function.length = size + 9;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_xinteger", 10);

    *dana = text + 10;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
line_xset(p_case_args_____1)
{
    int *line;
    char *text;
    unsigned size;

    linetext_data->context = lxtext_data;

    line = *args;

    linetext_data->function.args = line;

    *line++ = X1f4_E4_MODE;
    *line++ = X1f4_E4_BILL;

    *args = line;

    linetext_data->function.count = 2;

    linetext_data->function.flags = X1f4_E4_KEEP_CALL | X1f4_E4_TEXT_LINK;

    linetext_data->function.function = _libx1f4i0_lxnear_x_forward;

    size = lxtype_data->size;

    linetext_data->function.length = size + 10;

    text = *dana;

    linetext_data->function.name = text;

    memcpy(text, lxtype_data->name, size);
    text += size;
    memcpy(text, "_xcardinal", 11);

    *dana = text + 11;

    linetext_data->function.type = X1f4_E4_VOID;

    return 0;
}


static int
link_near(struct lxnear_type *lxnear_data, unsigned bits,
	  const struct screen_type *screen_data)
{
    int status;
    unsigned args_count, clip, fast, less, line_count, main_count, miss, none,
	slip, this;
    void *data;

    /*
     * TODO
     *
     * remove _args_ processing, switch to literal parameter lists
     */

    size_miss(&this, &clip, &none, &slip, &fast, &less, screen_data);

    pick_miss(&args_count, &line_count, &main_count, screen_data);

    miss = screen_data->link_t.miss;

    status = lxnear_data->link_w.link
	(lxnear_data->link_w.data, &data,
	 ft_size(miss) + fl_size(away) + ff_size(fast) + fa_size(slip)
	 - fa_size(none) + fy_size(this) - fy_size(less) - ff_size(clip)
	 + args_count * sizeof(int)
	 + line_count * sizeof(struct x1f4_linetext_type) + main_count);
    if (status) {
	status = LINK_ERROR;
    } else {
	void *args, *dana, *text;

	text = (struct x1f4_linetext_type *) data + ft_page(miss)
	    + fl_page(away) + f1_size(fast) - f1_size(clip) + line_count;
	args = (struct lxtext_type *) text + miss;
	dana = (int *) args + ft_line(miss) + f1_size(slip) - f1_size(none)
	    + args_count;

	lxnear_data->link_f.data = data;

	line_data(lxnear_data, bits, screen_data, data, text, &args, &dana);
    }

    return status;
}


static int
pick_miss(unsigned *args, unsigned *line, unsigned *pick,
	  const struct screen_type *screen_data)
{
    const struct lxtype_type *lxtype_data;
    unsigned args_count = 0, line_count = 0, i, main_count = 0;

    lxtype_data = screen_data->link_t.data;

    i = screen_data->link_t.miss;
    for (; i; i--) {
	unsigned deck;

	deck = lxtype_data->size + 1;

	args_count += fast_line_count;
	line_count += sizeof(fast_line) / sizeof(struct miss_type);
	main_count += deck * sizeof(fast_line) / sizeof(struct miss_type)
	    + fast_line_class;

	lxtype_data++;
    }

    *args = args_count;
    *line = line_count;
    *pick = main_count;

    return 0;
}


static int
size_miss(unsigned *miss, unsigned *clip, unsigned *none, unsigned *slip,
	  unsigned *text, unsigned *less,
	  const struct screen_type *screen_data)
{
    const struct lxtype_type *lxtype_data;
    unsigned dana = 0, fast = 0, i, mode = 0, nand = 0, post = 0, size = 0;

    lxtype_data = screen_data->link_t.data;

    i = screen_data->link_t.miss;
    for (; i; i--) {
	unsigned deck;

	deck = lxtype_data->size;

	size += deck * l___type_page;

	lxtype_data++;
    }

    *less = mode;
    *text = fast;
    *slip = nand;
    *none = post;
    *clip = dana;
    *miss = size;

    return 0;
}


static void
side_line(void *context, unsigned bits, const struct screen_type *screen_data,
	  struct x1f4_linetext_type *linetext_data,
	  const struct lxtype_type *lxtype_data, void **dana,
	  unsigned count, const struct miss_type *line_data)
{
    const char *name;
    char *text;
    unsigned size;

    size = lxtype_data->size;

    name = lxtype_data->name;

    text = *dana;

    while (count) {
	unsigned fail;

	linetext_data->context = context;

	linetext_data->function = line_data->function;

	fail = line_data->function.length;

	linetext_data->function.length = size + fail;

	linetext_data->function.name = text;

	fail++;

	memcpy(text, name, size);
	text += size;
	memcpy(text, line_data->function.name, fail);

	text += fail;

	linetext_data++;

	line_data++;

	count--;
    }

    *dana = text;
}


int
x1f4_init_lxnear(void **lxnear, unsigned bits,
		 const struct screen_type *screen_data)
{
    int (*link) (void *, void **, unsigned), status;
    void *near, *text;

    if (bits & CODELINK_LINK) {
	link = screen_data->link_w.link;
	text = screen_data->link_w.data;
    } else {
	link = _x1f4_e4_link_data;
	text = (void *) 0;
    }

    status = link(text, &near, sizeof(struct lxnear_type));
    if (status) {
	status = LINK_ERROR;
    } else {
	status = init_near(near, bits, screen_data);
	if (status) {
	    if (bits & CODELINK_LINK) {
		screen_data->link_w.free(text, near);
	    } else {
		_x1f4_e4_free_data(text, near);
	    }
	} else {
	    *lxnear = near;
	}
    }

    return status;
}
