/*
 * lxnear-l.r.c
 * Copyright (C) 2008-2010, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <config.h>

#if defined HAVE_LIBx1f4i0
# include <libx1f4i0.h>
#endif				/* HAVE_LIBx1f4i0 */

#include <e4.h>
#if !defined HAVE_LIBx1f4i0
# include <float.v.h>
#endif				/* !HAVE_LIBx1f4i0 */
#include <lxnear-types.h>

#define I_MODE(t)			(*((X1f4_E4_C_MODE *) (t)))
#define I_REAL(t)			(*((X1f4_E4_C_REAL *) (t)))

#define becca(context) \
    ((void **) (context))

int
_libx1f4i0_lxnear_r_logique(void *context, void *output, void **input)
{
    X1f4_E4_C_MODE p;
    int status;

    p = I_MODE(input[0]);
    if (p < 0) {
	status = 0;
    } else {
	struct lxtext_type *lxtext_data;

	lxtext_data = *becca(context);

	status = x1f4_vprint_float
	    (lxtext_data->data, lxtext_data->push, p, I_REAL(input[1]));
    }

    return status;
}
